package org.xml.sax.helpers;

import org.xml.sax.Parser;

public class ParserFactory
{
    private static SecuritySupport ss;
    
    private ParserFactory() {
    }
    
    public static Parser makeParser() throws ClassNotFoundException, IllegalAccessException, InstantiationException, NullPointerException, ClassCastException {
        String className = ParserFactory.ss.getSystemProperty("org.xml.sax.parser");
        if (className == null) {
            throw new NullPointerException("No value for sax.parser property");
        }
        return makeParser(className);
    }
    
    public static Parser makeParser(String className) throws ClassNotFoundException, IllegalAccessException, InstantiationException, ClassCastException {
        return (Parser)NewInstance.newInstance(ParserFactory.ss.getContextClassLoader(), className);
    }
    
    static {
        ParserFactory.ss = new SecuritySupport();
    }
}
